module App.Container

open System
open Actions
open Feliz

type State = { Date: DateTime }

let initialState = { Date = DateTime.Now }

let update (state: State) =
    function
    | Msg.ChangeDate dateTime -> { state with Date = dateTime }

[<ReactComponent>]
let Container () =
    let (state, dispatch) = React.useReducer (update, initialState)

    Html.div [ DatePicker.DatePicker(state.Date, dispatch)
               Html.ol [ UserEntry.UserEntry("a_mae_zing", state.Date)
                         UserEntry.UserEntry("Anthony", state.Date) ] ]
